VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmServer 
   Caption         =   "CornflakeZone Chat Server"
   ClientHeight    =   5085
   ClientLeft      =   7650
   ClientTop       =   4305
   ClientWidth     =   6225
   LinkTopic       =   "Form1"
   ScaleHeight     =   5085
   ScaleWidth      =   6225
   Begin VB.Timer tmServerTimer 
      Interval        =   100
      Left            =   5400
      Top             =   3840
   End
   Begin MSWinsockLib.Winsock sktConnection 
      Index           =   0
      Left            =   4920
      Top             =   3840
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox txtTotalIncoming 
      Height          =   2535
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   1800
      Width           =   6015
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   495
      Left            =   4080
      TabIndex        =   1
      Top             =   4440
      Width           =   2055
   End
   Begin VB.TextBox txtServerLog 
      Height          =   1095
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   360
      Width           =   6015
   End
   Begin VB.Label lblActiveConnections 
      Caption         =   "0 Active Connections"
      Height          =   255
      Left            =   3960
      TabIndex        =   5
      Top             =   120
      Width           =   2175
   End
   Begin VB.Label Label2 
      Caption         =   "Chat Session"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   3375
   End
   Begin VB.Label Label1 
      Caption         =   "Server Log"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   3375
   End
End
Attribute VB_Name = "frmServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private gHandles() As String
Private gSentYN() As Boolean
Private gMessages() As String


Private Sub cmdClose_Click()

    Dim i As Integer
    
    ' Close all the connections, including the server's
    For i = 0 To gNumConnections
        sktConnection(i).Close
    Next i
    
    'finally unload the server
    Unload Me
End Sub

Private Sub Form_Load()
       
    ' Only connection(0) listens, all others are connections
    sktConnection(0).Close
    sktConnection(0).LocalPort = gPort
    sktConnection(0).Listen
    
    ReDim gHandles(1) As String
    gHandles(0) = "Cornflake Server"
    AddToServerLog ("Server is Listening on port " & gPort)
    
End Sub

Private Sub sktConnection_Close(Index As Integer)
    ' Announce the new departure
    AddToTotalIncoming (gHandles(Index) & " just left")
    
    'close the connection
    sktConnection(Index).Close
    
End Sub

Private Sub sktConnection_ConnectionRequest(Index As Integer, ByVal requestID As Long)

    ' Now accept the new connection
    'A connection was requested from the server.

    Dim i As Integer
    Dim iConnection As Integer

    'Make sure this is control 0 in the array.
    'This is the only one that can accept connections.
    If Index = 0 Then
    
        'Search for available Winsock control.
        For i = 1 To gNumConnections
            If sktConnection(i).State = sckClosed Then
                iConnection = i
                Exit For
            End If
        Next i
        
        'If none was found, create a new one.
        If iConnection = 0 Then
        
            ' Tell the world there's a new connection
            gNumConnections = gNumConnections + 1
            
            'Load a new Winsock control for this connection.
            Load sktConnection(gNumConnections)
            
            ' This connection needs a handle
            ReDim Preserve gHandles(gNumConnections) As String
            ReDim Preserve gSentYN(gNumConnections) As Boolean
            ReDim Preserve gMessages(gNumConnections) As String
            
            ' Catch this user up on the previous conversation
            ' This way they don't get resent the chat session to date
            gMessages(gNumConnections) = gTotalincoming
            
            ' set their handle
            gHandles(gNumConnections) = "unknown"
            
            ' Add to the servers connections
            lblActiveConnections.Caption = gNumConnections & " Active Connections"
            
            'Control to be used is this new control.
            iConnection = gNumConnections
        End If
        
        'Set port for this control to 0.  (Randomly assigns an available port.)
        sktConnection(iConnection).LocalPort = 0
        
        'Have this control accept the connection.
        sktConnection(iConnection).Accept requestID
        
        ' Send the welcome message
        sktConnection(iConnection).SendData "Welcome to the CornflakeZone, enter your handle"
    End If
    
End Sub

Private Sub sktConnection_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    'Data has arrived at the server from an open connection.
    Dim newdata As String
        
    'Get the data.
    sktConnection(Index).GetData newdata
    
    If gHandles(Index) = "unknown" Then
    
        ' Store it internally
        gHandles(Index) = newdata
        
        ' Announce the new arrival
        AddToTotalIncoming (newdata & " just joined")
    Else
        'Pass the index of the connection from which the data came.
        AddToTotalIncoming (gHandles(Index) & ":: " & newdata)
    End If
    
End Sub

Private Sub sktConnection_Error(Index As Integer, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    ' this should handle all errors in the server world
    AddToServerLog ("Socket error on #" & Index & " " & Description)
End Sub

Private Sub tmServerTimer_Timer()
    txtTotalIncoming.Text = gTotalincoming
    
    'Send the new data to the group
    Call BroadcastMessage
        
End Sub

Private Sub BroadcastMessage()
    Dim i
    Dim myMessage  As String
    Dim conn_index As Integer
    
    ' Set the default connection index
    conn_index = -1
    
    ' Loop through all connections excluding the servers
    ' Hence we start at 1
    For i = 1 To gNumConnections
        ' if this connection has not had an update then
        If gSentYN(i) = False And sktConnection(i).State = sckConnected Then
            ' Get the message we need to deliver
            myMessage = Left(gTotalincoming, Len(gTotalincoming) - Len(gMessages(i)))
            ' update the message store for this user
            gMessages(i) = gTotalincoming
            ' Get the index of this connection
            conn_index = i
            Exit For
        'Else
         '   gSentYN(i) = True
        End If
    Next i
    
    ' This is so we know to
    ' send the data to everyone
    If conn_index = -1 Then
        For i = 1 To gNumConnections
            gSentYN(i) = False
        Next
    End If
    
    If conn_index > -1 Then
    
        ' check the connection's open
        If sktConnection(conn_index).State = sckConnected Then
            
            ' send the data
            sktConnection(conn_index).SendData myMessage
            
            'signal that we've sent to this user
            gSentYN(conn_index) = True
            
        End If
        
    End If

End Sub

